'use strict';

var AcessoController = angular.module('AcessoController', []);

AcessoController.controller('AcessoCtrl', ['$scope', '$routeParams', 'Construcao', 'Cliente', 'CacheApp', 'MsgBox',
    ($scope, $routeParams, Construcao, Cliente, CacheApp, MsgBox) => {

        $scope.excluiPermissao = (cliente) => {
            MsgBox.Pergunta(cliente.Nome, 'Confirma cancelamento das permissões?'
                , () => {
                    Construcao.delAcessosConstrucao(cliente,
                        (data) => {
                            var idx = $scope.compartilhados.indexOf(cliente)
                            $scope.compartilhados.splice(idx, 1);
                        });
                }
                , () => {
                });
        }

        $scope.getGrupoObra = () => {
            Construcao.getGrupoObra($scope.construcao.Id,
                (data) => {
                    var acessos = data.Instance;
                    $scope.listaGrupo = [];
                    if (acessos.length == 1 && acessos[0].IdGrupoAcesso == 5) {
                        $scope.acessosConstrucao.forEach(l => {
                            l.IdGrupoAcesso = l.IdGrupoAcesso != 5 && l.ChaveAcesso != "GET_COMPARTILHAMENTO" ? 5 : l.IdGrupoAcesso;
                            if ($scope.listaGrupo.filter(g => g && g.IdGrupoAcesso == l.IdGrupoAcesso).length == 0) {
                                var grupo = data.Instance.filter(g => g.IdGrupoAcesso == l.IdGrupoAcesso)[0];
                                if (grupo)
                                    $scope.listaGrupo.push(grupo);
                            }
                        });
                    }
                    else {
                        $scope.acessosConstrucao.forEach(l => {
                            if (!$scope.listaGrupo.some(g => g && g.IdGrupoAcesso == l.IdGrupoAcesso)) {
                                var grupo = data.Instance.filter(g => g.IdGrupoAcesso == l.IdGrupoAcesso)[0];
                                if (grupo)
                                    $scope.listaGrupo.push(grupo);
                            }
                        });
                    }
                });
        }

        $scope.adicionarPermissao = () => {
            $scope.desmarcaTudo();
            $scope.compartilhados = $scope.compartilhados ? $scope.compartilhados : [];
            var idCount = $scope.compartilhados.length;
            $scope.compartilhados.unshift({
                Novo: true,
                IdCliente: 0,
                IdConstrucao: $scope.construcao.Id,
                Acessos: [],
                AcessosID: [],
                NomeDigitado: '',
                Nome: '',
                IdCount: idCount
            });
        }

        $scope.cancelaPermissao = (cliente) => {
            if (cliente.IdCliente == 0) {
                var idx = $scope.compartilhados.indexOf(cliente)
                $scope.compartilhados.splice(idx, 1);
            }
            else {
                cliente.Novo = false;
                cliente.Nome = cliente.NomeDigitado;
            }
        }

        $scope.alteraPermissao = (cliente) => {
            $scope.deuErro = false;
            cliente.Novo = true;
            cliente.NomeDigitado = cliente.Nome;
            $scope.desmarcaTudo();
            
            $scope.acessosConstrucao.forEach( a => {
                var idx = cliente.AcessosID.indexOf(a.Id);
                a.check = idx >= 0;
            });
            $scope.marcaGrupo();

        }

        $scope.AcessoSelecionado = (acesso, cliente) => {
            var idx = cliente.AcessosID.indexOf(acesso.Id);
            if (idx < 0) {
                cliente.AcessosID.push(acesso.Id);
                cliente.Acessos.push(acesso);
            }
            else {
                cliente.AcessosID.splice(idx, 1);
                cliente.Acessos.splice(idx, 1);
            }
            
            if (!acesso.fromGrupo)
                $scope.marcaGrupo();
            else
                delete acesso.fromGrupo;
        }

        $scope.selecionaTodos = (grupo, cliente) => {
            if (grupo) {
                $scope.acessosConstrucao.filter(a => a.IdGrupoAcesso == grupo.IdGrupoAcesso).forEach(
                    a => {
                        if ((grupo.check && !a.check) || (!grupo.check && a.check)) {
                            a.check = grupo.check;
                            a.fromGrupo = true;
                            $scope.AcessoSelecionado(a,cliente);
                        }
                    }
                );
            }
            else {
                $scope.acessosConstrucao.forEach(
                    a => {
                        a.check = !a.check;
                        $scope.AcessoSelecionado(a,cliente);
                    }
                );
            }
        }

        $scope.marcaGrupo = () => {
            $scope.listaGrupo.forEach(g => {
                g.check = 
                    $scope.acessosConstrucao.filter(a => a.IdGrupoAcesso == g.IdGrupoAcesso).length ==
                    $scope.acessosConstrucao.filter(a => a.IdGrupoAcesso == g.IdGrupoAcesso && a.check).length;
                }
            );
        }

        $scope.desmarcaTudo = () => {
            $scope.acessosConstrucao.forEach( a => {
                a.check = false;
            });
            $scope.listaGrupo.forEach(g => {
                g.check = false;
            });
        }

        $scope.registraPermissao = (cliente) => {

            if (CacheApp.getSessao().TipoPlano == 3) {
                CacheApp.msgBoxAcessoPremium();
                return;
            }

            if (!cliente.Email || cliente.Email.length == 0) {
                MsgBox.Atencao('Atenção', `Informme o e-mail do usuário.`,
                () => {});
                return;
            }

            if (cliente.Acessos.length == 0) {
                MsgBox.Atencao('Atenção', `Nenhuma permissão foi selecionada.`,
                () => {});
                return;
            }

            Cliente.getClientes(cliente.Email,
                (data) => {
                    if (data.Instance.length == 1) {
                        if ($scope.construcao.IdClienteDono == data.Instance[0].IdCliente) {
                            MsgBox.Atencao(`Conta Administradora`, `O e-mail ${cliente.Email} é proprietário da obra.`,() => {});
                            return;
                        }
                        var params = {IdClienteAdmin: $scope.construcao.IdClienteDono}
                        Cliente.getPlanoContratado(params,
                            (contrato) => {
                                if (!contrato.Instance) {
                                    MsgBox.Atencao(`Limite de compartilhamento excedido`, `Caso necessário, entre em contato com nossos consultores.`,() => {});
                                    return;
                                }
                                Cliente.getUsuariosCompartilhado(params,
                                    (usrComp) => {
                                        var comp = usrComp.Instance;
                                        var usr = comp.filter(c => c.Email == cliente.Email);
                                        if (usr.length > 0 || contrato.Instance.Acessos > contrato.Instance.Compartilhado) {
                                            cliente.IdCliente = data.Instance[0].IdCliente;
                                            cliente.Nome = data.Instance[0].Nome;
                                            Construcao.setAcessoConstrucao(cliente,
                                                (result) => {
                                                    $scope.compartilhados = [];
                                                    $scope.getClientesConstrucao();
                                                }
                                            );
                                        }
                                        else
                                            MsgBox.Atencao(`Limite de compartilhamento excedido`, `Caso necessário, entre em contato com nossos consultores.`,() => {});
                                    }
                                );
                            }
                        );
            
                    }
                    else
                        MsgBox.Atencao(cliente.Email, `Não está cadastrado no Vigha.`,() => {});
                }
            );
        }

        $scope.getAcessosConstrucao = () => {
            var params = {
                IdConstrucao: $scope.construcao.Id,
                IdClienteAdmin: $scope.construcao.IdClienteDono
            }
            Construcao.getAcessosConstrucao(params,
                (data) => {
                    $scope.acessosConstrucao = data.Instance;
                    function listarAlfabeticamente() {
                        $scope.acessosConstrucao.sort(function (a, b) {
                            return a.IdGrupoAcesso - b.IdGrupoAcesso
                        })
                    }

                    if($scope.construcao.Tipo != 3){
                        for (var i in $scope.acessosConstrucao) {
                            if ($scope.acessosConstrucao[i].IdGrupoAcesso == 5) {
                                $scope.acessosConstrucao.splice(i, 1)
                            }
                        }
                    }

                    listarAlfabeticamente();
                    $scope.getGrupoObra();
                });
        }

        $scope.getClientesConstrucao = () => {
            Construcao.getClientesConstrucao($scope.construcao.Id,
                function (data) {
                    $scope.compartilhados = $scope.compartilhados ? $scope.compartilhados : [];
                    var count = 0;
                    for (var i in data.Instance) {
                        data.Instance[i].IdCount = count++;
                        data.Instance[i].IdConstrucao = $scope.construcao.Id;
                        data.Instance[i].NomeDigitado = data.Instance[i].Nome;
                        data.Instance[i].AcessosDescrito = '';
                        data.Instance[i].AcessosID = [];
                        for (var j in data.Instance[i].Acessos) {
                            if (j == 0)
                                data.Instance[i].AcessosDescrito += data.Instance[i].Acessos[j].Descricao;
                            else
                                data.Instance[i].AcessosDescrito += ', ' + data.Instance[i].Acessos[j].Descricao;

                            data.Instance[i].AcessosID.push(data.Instance[i].Acessos[j].Id);
                        }
                        $scope.compartilhados.push(data.Instance[i]);
                    }

                });
        }

        $scope.setarCliente = () => {
            var idsClientes = [19,23,36,40,54,55,78];
            $scope.acessosConstrucao.filter(a => idsClientes.indexOf(a.Id) >= 0).forEach(a => {
                a.check = !a.check;
                $scope.AcessoSelecionado(a, $scope.compartilhados[0]);
            });
        }

        $scope.AcessoAndroid($routeParams, function (sim) {
            $scope.AcessoMobile = sim;
            $scope.construcao = CacheApp.getConstrucao();
            $scope.getAcessosConstrucao();
            $scope.getClientesConstrucao();
        });
    }]);
